﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams;
using Telerik.Windows.Controls.Diagrams.Extensions;
using Telerik.Windows.Diagrams.Core;
using Telerik.Windows.DragDrop;

namespace WPF_Diagram_Application1
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var toolService = this.diagram.ServiceLocator.GetService<IToolService>() as ToolService;
            toolService.ToolList[0] = new MyPointerTool();
            toolService.ActivateTool(MyPointerTool.ToolName);
        }
    }

    public class MyPointerTool : PointerTool
    {
        public override bool MouseDown(PointerArgs e)
        {
            var result = base.MouseDown(e);
            if (this.HitItem != null && this.DontLikeHitItem())
                this.HitItem = null;

            return result;
        }

        private bool DontLikeHitItem()
        {
            return !MyProperties.GetCanSelect(this.HitItem as FrameworkElement);
        }
    }

    public static class MyProperties
    {
        public static readonly DependencyProperty CanSelectProperty =
            DependencyProperty.RegisterAttached("CanSelect", typeof(bool), typeof(MyProperties), new PropertyMetadata(true));

        public static bool GetCanSelect(DependencyObject obj)
        {
            return (bool)obj.GetValue(CanSelectProperty);
        }

        public static void SetCanSelect(DependencyObject obj, bool value)
        {
            obj.SetValue(CanSelectProperty, value);
        }
    }

}
